#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>

#include "interface_classes.h"

double triangularSimilarity(const State& s1, const State& s2, double* threshold){
 
  

  int i;
  double sim=1;
  double dimSim;

  for (i=0; i<State::dimensionality; i++){
    if (((s1.x[i]-threshold[i]) < s2.x[i]) && (s2.x[i] <= s1.x[i]))
      dimSim = 1-(s1.x[i]-s2.x[i])/threshold[i];
    else
      if ( (s1.x[i] <= s2.x[i]) && (s2.x[i] < (s1.x[i]+threshold[i])))
	dimSim = 1-(s2.x[i]-s1.x[i])/threshold[i];
      else
	dimSim = 0;

    if (dimSim < sim) sim = dimSim;

  }

  return sim;

}
